From 1bcc9fe2e572da51f1e2ac2e5cda14ac971e6bea Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:17 +0000
Subject: [PATCH 444/2232] Test returning opaque types in CxxVector from C to Rust


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index a16775b..d6a94e4 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -30,6 +30,7 @@ pub mod ffi {
         fn c_return_unique_ptr_vector_u8() -> UniquePtr<CxxVector<u8>>;
         fn c_return_unique_ptr_vector_f64() -> UniquePtr<CxxVector<f64>>;
         fn c_return_unique_ptr_vector_shared() -> UniquePtr<CxxVector<Shared>>;
+        fn c_return_unique_ptr_vector_opaque() -> UniquePtr<CxxVector<C>>;
 
         fn c_take_primitive(n: usize);
         fn c_take_shared(shared: Shared);
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 502be05..372641c 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -83,6 +83,10 @@ std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared() {
   return vec;
 }
 
+std::unique_ptr<std::vector<C>> c_return_unique_ptr_vector_opaque() {
+  return std::unique_ptr<std::vector<C>>(new std::vector<C>());
+}
+
 void c_take_primitive(size_t n) {
   if (n == 2020) {
     cxx_test_suite_set_correct();
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index e1e163d..ed07ce6 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -32,6 +32,7 @@ std::unique_ptr<std::string> c_return_unique_ptr_string();
 std::unique_ptr<std::vector<uint8_t>> c_return_unique_ptr_vector_u8();
 std::unique_ptr<std::vector<double>> c_return_unique_ptr_vector_f64();
 std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared();
+std::unique_ptr<std::vector<C>> c_return_unique_ptr_vector_opaque();
 
 void c_take_primitive(size_t n);
 void c_take_shared(Shared shared);

